/*Measure Up
A script to quickly change the Display Unit Scale with a single button click
created 2010 for 3DS Max 2010
by Marc Florestant
www.marcflorestant.com*/

	
/***Interface Setup***/
fn openMeasureFloater =
(
local result = false --flag for success/failure
local oldPannel = getCommandPanelTaskMode() --remember the old command panel tab
UtilityPanel.OpenUtility measure --open Utility tab and enable Measure Utility
local theMeasureUtil = windows.getChildHWND #max "Measure" --grab the Measure's rollout handle
if theMeasureUtil.count > 0 do --if it was found,
(
local theButton = windows.getChildHWND theMeasureUtil[2] "New Floater" --get the New Floater button's handle
if theButton.count > 0 do --if this succeeded too, then send messages to click it
(
Windows.sendMessage theButton[1] 0x201 0 0 --Left Mouse Button Down
Windows.sendMessage theButton[1] 0x202 0 0 --Left Mouse Button Up
result = true --raise the flag for success
)
)
setCommandPanelTaskMode oldPannel --switch back to the previous command panel tab
result --return result
)

rollout measureUp_rollOut "Units, Measurements & Reset" width:320 height:260
(
	button measMeasButton "Measure" pos:[8,66] width:93 height:20 toolTip:"Open Measure Utility"
	button feetFrakInchButton "Feet Frac. Inches" pos:[205,137] width:93 height:28 toolTip:"Set Units to Feet Fractional Inches"
	GroupBox USTypeGrpBox "US Standard" pos:[9,90] width:295 height:81
	button feetDecInchButton "Feet Dec. Inches" pos:[205,105] width:93 height:28 toolTip:"Set Units to Feet Decimal Inches"
	button decFeetButton "Decimal Feet" pos:[109,105] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	button frakFeetButton "Fractional Feet" pos:[109,137] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	button decInchesButton "Decimal Inches" pos:[13,105] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	button frakInchesButton "Fractional Inches" pos:[13,137] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	GroupBox metricTypeGrpBox "Metric" pos:[103,6] width:201 height:80
	button centimeterButton "Centimeters" pos:[204,20] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	button kilometerButton "Kilometers" pos:[204,52] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	button millimeterButton "Millimeters" pos:[108,20] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	button meterButton "Meters" pos:[108,52] width:93 height:28 toolTip:"Set Units to Decimal Feet"
	button genericButton "Generic" pos:[8,18] width:93 height:20 toolTip:"Set Units to Decimal Feet"
	button customButton "Custom" pos:[8,42] width:93 height:20 toolTip:"Set Units to Decimal Feet"

	GroupBox usefulTypeGrpBox "Useful Options" pos:[8,180] width:295 height:50
	button xfrmButton "Reset Xform" pos:[12,196] width:93 height:28 toolTip:"Reset Xform"
	button mouselostButton "Reset X,Y,Z" pos:[108,196] width:93 height:28 toolTip:"Reset X,Y,Z"
	button taketwoButton "Reset All" pos:[204,196] width:93 height:28 toolTip:"Reset All"
	--Process the button pushing

	on feetFrakInchButton pressed do
	(
		units.displayType= #US
		units.USType= #Ft_Frac_In
	)
	on feetDecInchButton pressed do
	(
		units.displayType= #US
		units.USType= #Ft_Dec_In
	)
	on decFeetButton pressed do
	(
		units.displayType= #US
		units.USType= #Dec_Ft
	)
	on frakFeetButton pressed do
	(
		units.displayType= #US
		units.USType= #Frac_Ft
	)
	on decInchesButton pressed do
	(
		units.displayType= #US
		units.USType= #Dec_In
	)
	on frakInchesButton pressed do
	(
		units.displayType= #US
		units.USType= #Frac_In
	)
	on centimeterButton pressed do
	(
		units.displayType= #Metric
		units.metricType= #Centimeters
	)
	on kilometerButton pressed do
	(
		units.displayType= #Metric
		units.metricType= #Kilometers
	)
	on millimeterButton pressed do
	(
		units.displayType= #Metric
		units.metricType= #Millimeters
	)
	on meterButton pressed do
	(
		units.displayType= #Metric
		units.metricType= #Meters
	)
	on genericButton pressed do
	(
		units.displayType= #Generic
	)
	on customButton pressed do
	(
		units.displayType= #Custom
	)
		on measMeasButton pressed do
	(
		fileIn "objectinfo2.mse"
	)

	on xfrmButton pressed do
	(
		resetxform selection
		collapsestack selection
	)
	on mouselostButton pressed do
	(
		myObj = $ -- get selected object
		myObj.pos = [0,0,0] -- set to 0
	)
	on taketwoButton pressed do
	(
		resetxform selection
		collapsestack selection
		myObj = $ -- get selected object
		myObj.pos = [0,0,0] -- set to 0
	)
)


--Create the Rollout
measureFloater = newRolloutFloater "Units, Measurements & Reset" 320 260
addRollOut measureUp_rollOut measureFloater

/***End Interface Setup***/
